"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeterministicFiniteAutomatonUtils = exports.DeterministicFiniteAutomaton = void 0;
const FiniteAutomaton_1 = require("../FiniteAutomaton");
const DeterministicFiniteAutomatonUtils = __importStar(require("./utils"));
exports.DeterministicFiniteAutomatonUtils = DeterministicFiniteAutomatonUtils;
class DeterministicFiniteAutomaton extends FiniteAutomaton_1.FiniteAutomaton {
    constructor(testLogic, automaton, automatonId) {
        super(testLogic, automaton, 'deterministic', automatonId);
    }
    #merge(finiteAutomaton, mergeOperation, generatedAutomatonOptions) {
        const { automaton, testLogic, automatonId } = DeterministicFiniteAutomatonUtils.merge({
            automaton: this.automaton,
            automatonId: this.getAutomatonId(),
            testLogic: this.testLogic,
        }, finiteAutomaton
            ? {
                automaton: finiteAutomaton.automaton,
                automatonId: finiteAutomaton.getAutomatonId(),
                testLogic: finiteAutomaton.testLogic,
            }
            : undefined, mergeOperation, generatedAutomatonOptions);
        return new DeterministicFiniteAutomaton(testLogic, automaton, automatonId);
    }
    AND(dfaModule, generatedAutomatonOptions) {
        return this.#merge(dfaModule, 'and', generatedAutomatonOptions);
    }
    NOT(generatedAutomatonOptions) {
        return this.#merge(undefined, 'not', generatedAutomatonOptions);
    }
    OR(dfaModule, generatedAutomatonOptions) {
        return this.#merge(dfaModule, 'or', generatedAutomatonOptions);
    }
    generateStateGroupsRecord(stateGroups) {
        return DeterministicFiniteAutomatonUtils.generateStateGroupsRecord(this.automaton.states, stateGroups);
    }
    generateEquivalenceStates(stateGroups) {
        return DeterministicFiniteAutomatonUtils.generateEquivalenceStates(this.automaton, stateGroups);
    }
    minimize(minimizedDfaOptions) {
        return new DeterministicFiniteAutomaton(this.testLogic, DeterministicFiniteAutomatonUtils.minimize(this.automaton, minimizedDfaOptions));
    }
}
exports.DeterministicFiniteAutomaton = DeterministicFiniteAutomaton;
