"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FiniteAutomataTestUtils = exports.FiniteAutomataTest = void 0;
const cli_progress_1 = __importDefault(require("cli-progress"));
const colors_1 = __importDefault(require("colors"));
const fs_1 = __importDefault(require("fs"));
const FiniteAutomataTestUtils = __importStar(require("./utils"));
exports.FiniteAutomataTestUtils = FiniteAutomataTestUtils;
class FiniteAutomataTest {
    #cliProgressBar;
    #logsPath;
    constructor(logsPath) {
        this.#cliProgressBar = new cli_progress_1.default.SingleBar({
            barsize: 20,
            stopOnComplete: true,
            format: `${colors_1.default.green('{bar}')} {percentage}% {value}/{total} Chunks`,
        }, cli_progress_1.default.Presets.shades_classic);
        this.#logsPath = logsPath;
        if (!fs_1.default.existsSync(logsPath)) {
            fs_1.default.mkdirSync(logsPath);
        }
    }
    createFileWriteStreams(automatonLabel, outputFiles) {
        return FiniteAutomataTestUtils.createFileWriteStreams(this.#logsPath, automatonLabel, outputFiles);
    }
    testAutomata(finiteAutomaton, finiteAutomatonTestInfo, writeStreams, inputStrings) {
        FiniteAutomataTestUtils.testAutomaton(finiteAutomaton, finiteAutomatonTestInfo, writeStreams, inputStrings, () => {
            this.#cliProgressBar.increment(1);
        });
    }
    async test(configs) {
        FiniteAutomataTestUtils.test(this.#logsPath, configs, (totalInputStrings) => {
            this.#cliProgressBar.start(totalInputStrings, 0, {
                speed: 'N/A',
            });
        }, () => {
            this.#cliProgressBar.increment(1);
        });
    }
}
exports.FiniteAutomataTest = FiniteAutomataTest;
