"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FiniteAutomatonUtils = exports.FiniteAutomaton = void 0;
const shortid_1 = __importDefault(require("shortid"));
const FiniteAutomatonUtils = __importStar(require("./utils"));
exports.FiniteAutomatonUtils = FiniteAutomatonUtils;
class FiniteAutomaton {
    testLogic;
    automaton;
    #automatonId;
    #automatonType;
    constructor(testLogic, finiteAutomaton, automatonType, automatonId) {
        this.#automatonType = automatonType;
        this.#automatonId = automatonId ?? (0, shortid_1.default)();
        this.testLogic = testLogic;
        FiniteAutomatonUtils.validate(finiteAutomaton.label, FiniteAutomatonUtils.generatePreNormalizationErrors(testLogic, this.#automatonType, finiteAutomaton));
        this.automaton = FiniteAutomatonUtils.normalize(finiteAutomaton);
        FiniteAutomatonUtils.validate(finiteAutomaton.label, FiniteAutomatonUtils.generatePostNormalizationErrors(finiteAutomaton));
    }
    getAutomatonId() {
        return this.#automatonId;
    }
    generateGraphFromString(inputString) {
        return FiniteAutomatonUtils.generateGraphFromString(this.automaton, inputString);
    }
    test(inputString) {
        return this.generateGraphFromString(inputString).automatonTestResult;
    }
}
exports.FiniteAutomaton = FiniteAutomaton;
