import { GeneratedAutomatonOptions, IAutomatonTestLogicFn, InputFiniteAutomaton } from '../../types';
import { DeterministicFiniteAutomaton } from '../DeterministicFiniteAutomaton';
import { FiniteAutomaton } from '../FiniteAutomaton';
import * as NonDeterministicFiniteAutomatonUtils from './utils';
export declare class NonDeterministicFiniteAutomaton extends FiniteAutomaton {
    constructor(testLogic: IAutomatonTestLogicFn, automaton: InputFiniteAutomaton, automatonId?: string);
    convertToRegularNfa(): void;
    epsilonClosureOfState(state: string): string[];
    moveAndEpsilonClosureStateSet(states: string[], symbol: string): string[];
    convertToDeterministicFiniteAutomaton(dfaOptions?: GeneratedAutomatonOptions): DeterministicFiniteAutomaton;
}
export { NonDeterministicFiniteAutomatonUtils };
