"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NonDeterministicFiniteAutomatonUtils = exports.NonDeterministicFiniteAutomaton = void 0;
const DeterministicFiniteAutomaton_1 = require("../DeterministicFiniteAutomaton");
const FiniteAutomaton_1 = require("../FiniteAutomaton");
const NonDeterministicFiniteAutomatonUtils = __importStar(require("./utils"));
exports.NonDeterministicFiniteAutomatonUtils = NonDeterministicFiniteAutomatonUtils;
class NonDeterministicFiniteAutomaton extends FiniteAutomaton_1.FiniteAutomaton {
    constructor(testLogic, automaton, automatonId) {
        super(testLogic, automaton, 'non-deterministic', automatonId);
        if (this.automaton.epsilon_transitions) {
            this.convertToRegularNfa();
        }
    }
    convertToRegularNfa() {
        NonDeterministicFiniteAutomatonUtils.convertToRegularNfa(this.automaton);
    }
    epsilonClosureOfState(state) {
        return NonDeterministicFiniteAutomatonUtils.epsilonClosureOfState(this.automaton.epsilon_transitions, state);
    }
    moveAndEpsilonClosureStateSet(states, symbol) {
        return NonDeterministicFiniteAutomatonUtils.moveAndEpsilonClosureStateSet(this.automaton.transitions, this.automaton.epsilon_transitions, states, symbol);
    }
    convertToDeterministicFiniteAutomaton(dfaOptions) {
        return new DeterministicFiniteAutomaton_1.DeterministicFiniteAutomaton(this.testLogic, NonDeterministicFiniteAutomatonUtils.convertToDeterministicFiniteAutomaton(this.automaton, dfaOptions));
    }
}
exports.NonDeterministicFiniteAutomaton = NonDeterministicFiniteAutomaton;
